"use strict";
var rxjs_1 = require('rxjs');
// null scheduler is the old immediate scheduler
// queue scheduler is the old currentThread scheduler
// asap scheduler is the old default scheduler
// this is a really hacky way of detecting if we're running in the
// context of a unit test runner
function isInTestRunner(g, w) {
    if (g === void 0) { g = global; }
    if (w == null) {
        w = g.window;
    }
    return ((g != null && (g.isUnitTestRunner === true ||
        typeof g.it === 'function' ||
        typeof g.chai === 'function' ||
        typeof g.sinon === 'function')) || (w != null && (w.isUnitTestRunner === true ||
        typeof w.jasmine !== 'undefined' ||
        typeof w.getJasmineRequireObj === 'function')));
}
var ReactiveApp = (function () {
    function ReactiveApp() {
    }
    ReactiveApp.createMainScheduler = function () {
        // NOTE: The queue scheduler is the currentThread scheduler
        // NOTE: The asap scheduler is the default scheduler
        return ReactiveApp.isUnitTestRunner ?
            rxjs_1.Scheduler.queue :
            rxjs_1.Scheduler.asap;
    };
    // if you're running a unit test, set this to true
    ReactiveApp.isUnitTestRunner = isInTestRunner();
    ReactiveApp.defaultErrorHandler = rxjs_1.Subscriber.create(function (err) {
        // console.error is a reasonable default here
        // tslint:disable-next-line no-console
        console.error(err);
    });
    ReactiveApp.mainScheduler = ReactiveApp.createMainScheduler();
    return ReactiveApp;
}());
exports.ReactiveApp = ReactiveApp;

//# sourceMappingURL=ReactiveApp.js.map
